//+------------------------------------------------------------------+
//|                                   sm00Level SignalMatrix_v3.0.mq4
//+------------------------------------------------------------------+
#property copyright "Copyright 28.03.2015, SwingMan"
#property strict
#property indicator_separate_window

string IndicatorName="sm00Level SignalMatrix_v3.0";

/*--------------------------------------------------------------------
19.03.2015  v1.0 CONDITIONS FOR THE CURRENT BAR:
               - SIGNAL                                     3  colors     
               - Absolute Strength                          2
               - (HeikinAshi)                               2
               - H1 Bar Color                               2
               - D1 Bar Color                               2
               FILTERS:
               - (Position Close to Daily Open)             2
               - Trading Hours (London, New York)           2
               - Previous Long Bar (2 ATR)                  2
               - Daily Range (Between Hilo +- daily ATR)    2
                                                          -----
                                                           15 
23.03.2015  v1.1  - Show or dont show some rows
25.03.2015  v3.0  - with Tma Slope / H1,D1 to Open in the same row
--------------------------------------------------------------------*/

#property indicator_buffers 16
//...............................................
//---- defines
#define clrText clrDodgerBlue

#define clrFilterOK clrDodgerBlue
#define clrNeutral clrGray

#define clrSignalBUY clrForestGreen
#define clrSignalSELL clrRed
//...............................................
//CONDITIONS FOR THE CURRENT BAR:
#property indicator_color1 clrSignalBUY    //Signal
#property indicator_color2 clrSignalSELL
#property indicator_color3 clrNeutral

#property indicator_color4 clrSignalBUY    //AbsoluteStrength
#property indicator_color5 clrSignalSELL
#property indicator_color6 clrNeutral

#property indicator_color7 clrSignalBUY    //H1 bar color
#property indicator_color8 clrSignalSELL

#property indicator_color9 clrSignalBUY    //D1 bar color
#property indicator_color10 clrSignalSELL

//FILTERS:
#property indicator_color11 clrFilterOK    //Trading Hours
#property indicator_color12 clrNeutral

#property indicator_color13 clrFilterOK    //Previous Long Bar
#property indicator_color14 clrNeutral

#property indicator_color15 clrFilterOK    //Daily Range (Between Hilo +- daily ATR)
#property indicator_color16 clrNeutral

//...............................................
#property indicator_width1 2
#property indicator_width2 2
#property indicator_width3 1
#property indicator_width4 1
#property indicator_width5 1
#property indicator_width6 0
#property indicator_width7 1
#property indicator_width8 1
#property indicator_width9 3
#property indicator_width10 3
#property indicator_width11 1
#property indicator_width12 1
#property indicator_width13 1
#property indicator_width14 1
#property indicator_width15 1
#property indicator_width16 1
//...............................................
#property indicator_minimum 0
#property indicator_maximum 8
//...............................................
enum ENUM_MODE_ABSOLUTE_STRENGTH
  {
   RSI_method_0=0,
   Stochastic_method_1=1
  };
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
enum ENUM_TREND_METHOD
  {
   AbsoluteStrength,
   TmaSlope
  };
//...............................................
//
//---- INPUTS
//===================================================================
input ENUM_TREND_METHOD TrendStrength=TmaSlope; //AbsoluteStrength
input string ____AbsoluteStrength="----------------------------------------------------";
input ENUM_APPLIED_PRICE Price=PRICE_CLOSE;
input ENUM_MODE_ABSOLUTE_STRENGTH Mode=RSI_method_0;
input int Length=5;
input int Smooth=4;
input ENUM_MA_METHOD ModeMA=MODE_EMA;
input string ____Tma_MovingAverage="----------------------------------------------------";
input int Tma_Period=3;
input int Slope_Distance=1;
input double Slope_Treshold=0.015;
input string ____Trading_Hours="----------------------------------------------------";
input int DailyOpen_TimeOffset=-1;
input string FraLondon_Open ="07:00";
input string FraLondon_Close="23:00";
input string NewYork_Open   ="16:00";
input string NewYork_Close  ="20:00";
input string Tokyo_Open     ="23:00";
input string Tokyo_Close    ="06:00";
input string ____ATR="----------------------------------------------------";
input int ATR_Period=14;
input int ATR_SmoothingPeriod=5;
input double ATR_LongBar_Factor=30.0;
input string ____Show_Informations="----------------------------------------------------";
input int Text_Spacing=16;
input bool Show_FilterBlock=false;
input bool Show_LeftTime=true;
input bool Show_CurrentPrice=true;
input bool Draw_DailyOpenLine=false;
input color DailyOpenLine_Color=CornflowerBlue;
input int maxBars=500;
//===================================================================
//...
//===================================================================
//
//
//---- constants
string CR="\n";
int iWindow= -1;
int iCorner= 3;
int rowTextHeight=8;

int yStep; //=13;
int xx0= 3;
int yy0= 8;
int yy;

int TREND_UP=  100;
int TREND_DN= -100;
int TREND_NO=990;

//string objDefault="t2_";
string objDefault;
string sObjName2_LeftTime="t2_LeftTime";
string sObjName2_CurrentPrice="t2_CurrentPrice";

//...............................................
//---- variables
int limit;
datetime thisTime,oldTime,thisDay,oldDay;
bool newBar,newDay;
double currATR,dailyATR;
int maxPeriod;
double maxDailyHigh,minDailyLow,dailyOpen;
string sThisDay;
datetime DiffTime_Broker_GMT;

//---- buffer signals
double SignalUP[],SignalDN[],SignalNO[];
double AbsStrengthUP[],AbsStrengthDN[],AbsStrengthNO[];
double BarColorH1UP[],BarColorH1DN[];
double BarColorD1UP[],BarColorD1DN[];
//double CloseOpenD1UP[],CloseOpenD1DN[];
//---- buffer filters
double TradingHourOK[],TradingHourNOK[];
double DailyRangeOK[],DailyRangeNOK[];
double PreviusSmallBarOK[],PreviusSmallBarNOK[];
//---- more buffers
double signalValue[];

//...............................................
#include <stderror.mqh>
#include <stdlib.mqh>
#include <sm00Level\sm00Level_CommonIncludes.mqh>
//
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int OnInit()
  {
   int iArrowTNO=110;

   int iArrowSigUP=233; //221; //233; //221;
   int iArrowSigDN=234; //222; //234; //222;
   int iArrowSigNO=159;

//int iArrowBar=51;//110;//167/127
   int iArrowBarD1=127;//110;//51;//110;//167/127
   int iArrowBarH1=110;//110;//51;//110;//167/127

   int iArrowCond=110;//167

   int iArrowFilterOK=108;
   int iArrowFilterNOK=159;//108;
                           //int iArrowOpenUP=217;
//int iArrowOpenDN=218;

//--- signal buffers
   SetIndexBuffer(0,SignalUP); SetIndexStyle(0,DRAW_ARROW); SetIndexArrow(0,iArrowSigUP); SetIndexLabel(0,"Signal UP");
   SetIndexBuffer(1,SignalDN); SetIndexStyle(1,DRAW_ARROW); SetIndexArrow(1,iArrowSigDN); SetIndexLabel(1,"Signal DOWN");
   SetIndexBuffer(2,SignalNO); SetIndexStyle(2,DRAW_ARROW); SetIndexArrow(2,iArrowSigNO); SetIndexLabel(2,NULL);

   SetIndexBuffer(3,AbsStrengthUP); SetIndexStyle(3,DRAW_ARROW); SetIndexArrow(3,iArrowCond); SetIndexLabel(3,NULL);
   SetIndexBuffer(4,AbsStrengthDN); SetIndexStyle(4,DRAW_ARROW); SetIndexArrow(4,iArrowCond); SetIndexLabel(4,NULL);
   SetIndexBuffer(5,AbsStrengthNO); SetIndexStyle(5,DRAW_ARROW); SetIndexArrow(5,iArrowCond); SetIndexLabel(5,NULL);

   SetIndexBuffer(6,BarColorH1UP); SetIndexStyle(6,DRAW_ARROW); SetIndexArrow(6,iArrowBarH1); SetIndexLabel(6,NULL);
   SetIndexBuffer(7,BarColorH1DN); SetIndexStyle(7,DRAW_ARROW); SetIndexArrow(7,iArrowBarH1); SetIndexLabel(7,NULL);

   SetIndexBuffer(8,BarColorD1UP); SetIndexStyle(8,DRAW_ARROW); SetIndexArrow(8,iArrowBarD1); SetIndexLabel(8,NULL);
   SetIndexBuffer(9,BarColorD1DN); SetIndexStyle(9,DRAW_ARROW); SetIndexArrow(9,iArrowBarD1); SetIndexLabel(9,NULL);

//--- filter buffers
   SetIndexBuffer(10,TradingHourOK); SetIndexStyle(10,DRAW_ARROW); SetIndexArrow(10,iArrowFilterOK); SetIndexLabel(10,NULL);
   SetIndexBuffer(11,TradingHourNOK); SetIndexStyle(11,DRAW_ARROW); SetIndexArrow(11,iArrowFilterNOK); SetIndexLabel(11,NULL);

   SetIndexBuffer(12,DailyRangeOK); SetIndexStyle(12,DRAW_ARROW); SetIndexArrow(12,iArrowFilterOK); SetIndexLabel(12,NULL);
   SetIndexBuffer(13,DailyRangeNOK); SetIndexStyle(13,DRAW_ARROW); SetIndexArrow(13,iArrowFilterNOK); SetIndexLabel(13,NULL);

   SetIndexBuffer(14,PreviusSmallBarOK); SetIndexStyle(14,DRAW_ARROW); SetIndexArrow(14,iArrowFilterOK); SetIndexLabel(14,NULL);
   SetIndexBuffer(15,PreviusSmallBarNOK); SetIndexStyle(15,DRAW_ARROW); SetIndexArrow(15,iArrowFilterNOK); SetIndexLabel(15,NULL);

   if(Show_FilterBlock==false)
     {
      SetIndexStyle(10,DRAW_NONE);
      SetIndexStyle(11,DRAW_NONE);

      SetIndexStyle(12,DRAW_NONE);
      SetIndexStyle(13,DRAW_NONE);

      SetIndexStyle(14,DRAW_NONE);
      SetIndexStyle(15,DRAW_NONE);
      
      IndicatorSetDouble(INDICATOR_MAXIMUM,4);
     }

//--- more buffers
   IndicatorBuffers(17);
   SetIndexBuffer(16,signalValue);

//--- initialisations -------------------------------------
   oldTime=0;
   oldDay=0;
   IndicatorDigits(Digits);
   yStep=Text_Spacing;

//datetime BrokerTime=TimeCurrent();
//datetime GMTTime=TimeGMT();
   DiffTime_Broker_GMT=TimeCurrent()-TimeGMT();

   if(TrendStrength==AbsoluteStrength)
     {
      DeleteAllObjects("t2_");
      objDefault="t2_";      
      IndicatorName=IndicatorName+"-ash";
      IndicatorShortName(IndicatorName);
      //IndicatorSetInteger()
     }
   else
   if(TrendStrength==TmaSlope)
     {
      DeleteAllObjects("t3_");
      objDefault="t3_";
      IndicatorName=IndicatorName+"-tma";
      IndicatorShortName(IndicatorName);
     }

//int GMT_offset=TimeGMTOffset()/3600; //-1
//Comment("GMT_offset=",GMT_offset,    
//        "   GMT=",TimeGMT(),         //14:17 = GMT
//        "  Local=",TimeLocal(),      //15:17 = Local
//        "  Current=",TimeCurrent()); //16:17 = Broker

   return(INIT_SUCCEEDED);
  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
void OnDeinit(const int reason)
  {
//--- indicator buffers mapping
   Comment("");
   if(TrendStrength==AbsoluteStrength)
      DeleteAllObjects("t2_");
   else
      DeleteAllObjects("t3_");
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int OnCalculate(const int rates_total,
                const int prev_calculated,
                const datetime &time[],
                const double &open[],
                const double &high[],
                const double &low[],
                const double &close[],
                const long &tick_volume[],
                const long &volume[],
                const int &spread[])
  {
//----------------------------------
   if(iWindow==-1)
     {
      iWindow=WindowFind(IndicatorName);
      Write_InfoText();
     }

   if(Show_LeftTime) Show_LeftTimeValue(); else ObjectDelete(sObjName2_LeftTime);
   if(Show_CurrentPrice) Show_CurrentPriceX(); else ObjectDelete(sObjName2_CurrentPrice);

//----------------------------------     
//limit=rates_total-prev_calculated;
//if(limit==0)
//  limit++;

   int counted_bars=IndicatorCounted();
//---- check for possible errors
   if(counted_bars<0) return(-1);
//---- the last counted bar will be recounted
   if(counted_bars>0) counted_bars--;
   limit=Bars-counted_bars;

//---- main loop
   if(limit>maxBars) limit=maxBars;
   for(int i=limit; i>=0; i--)
     {
      double row=0;
      //-- new bar ----------------------------------------
      if(iTime(Symbol(),Period(),i)!=oldTime)
        {
         oldTime=iTime(Symbol(),Period(),i);
         newBar=true;
        }
      else
         newBar=false;
      // 0. current and daily ATR
      double thisATR,sumI;
      if(newBar)
        {
         thisATR=0;
         sumI=0;
         for(int ia=1; ia<=ATR_SmoothingPeriod; ia++)
           {
            thisATR=thisATR+iATR(Symbol(),Period(),ATR_Period,i+ia);
            sumI++;
           }
         currATR=thisATR/sumI;

         //if(Draw_DailyOpenLine) Draw_DailyOpen_Line(dailyOpen,"newBar");
        }
      //-- new day ----------------------------------------
      int iD1Bar=iBarShift(Symbol(),PERIOD_D1,iTime(Symbol(),Period(),i),true);
      if(iTime(Symbol(),PERIOD_D1,iD1Bar)!=oldDay)
        {
         oldDay=iTime(Symbol(),PERIOD_D1,iD1Bar);
         newDay=true;

         sThisDay=TimeToString(iTime(Symbol(),Period(),i));
         sThisDay=StringSubstr(sThisDay,0,10)+" "; //#2015.03.20 #
        }
      else
         newDay=false;
      // 0. daily ATR
      if(newDay)
        {
         thisATR=0;
         sumI=0;
         for(int ia=1; ia<=ATR_SmoothingPeriod; ia++)
           {
            thisATR=thisATR+iATR(Symbol(),PERIOD_D1,ATR_Period,iD1Bar+ia);
            sumI++;
           }
         dailyATR=thisATR/sumI;
         maxDailyHigh=iOpen(Symbol(),Period(),i);
         minDailyLow=iOpen(Symbol(),Period(),i);

         dailyOpen=iOpen(Symbol(),Period(),i);
         if(Draw_DailyOpenLine) Draw_DailyOpen_Line(dailyOpen,i);
        }

      //-- current values
      double dCurrentHigh=iHigh(Symbol(),Period(),i);
      double dCurrentLow=iLow(Symbol(),Period(),i);
      if(dCurrentHigh>maxDailyHigh) maxDailyHigh=dCurrentHigh;
      if(dCurrentLow<minDailyLow) minDailyLow=dCurrentLow;
      //Comment(
      //"dailyATR=",dailyATR,CR,
      //"dClose=",iClose(Symbol(),Period(),i),CR,
      //"limit=",limit,CR,
      //"rates_total    =",rates_total,CR,
      //"prev_calculated=",prev_calculated
      //);         
      //***************************************
      // 1.. Filter: Daily Range (Between Hilo +- daily ATR)
      //***************************************
      if(Show_FilterBlock) row=row+1; else row=1;
      if(newDay)
        {
         DailyRangeOK[i]=row;
         DailyRangeNOK[i]=EMPTY_VALUE;
        }
      GetFilter_DailyRange(dailyATR,row,i);

      //***************************************
      // 2.. Filter: Previous Short Bar (Hilo <2 ATR)
      //***************************************
      if(Show_FilterBlock) row=row+1;
      GetFilter_PreviousShortBar(currATR,row,i);

      //***************************************
      // 3.. Filter: Trading Hours (London, New York)
      //***************************************
      if(Show_FilterBlock) row=row+1;
      GetFilter_TradingHours(row,i);

      //***************************************
      // 4.. D1 Bar Color
      //***************************************
      if(Show_FilterBlock)
        {
         row=row+1;
         row=row+0.30;
        }
      GetCond_D1BarColor(PERIOD_D1,row,i);

      //***************************************
      // 5.. H1 Bar Color
      //***************************************
      //row=row+1;
      GetCond_H1BarColor(PERIOD_H1,row,i);

      //***************************************
      // 6.. Absolute Strength
      //***************************************
      row=row+1;
      if(TrendStrength==AbsoluteStrength)
         GetCond_AbsoluteStrength(row,i);
      else
      if(TrendStrength==TmaSlope)
         GetCond_TmaSlope(row,i);

      //***************************************
      // 7.. SIGNAL
      //***************************************
      row=row+1;
      Get_TradingSignal(row,i);
     }
//--- return value of prev_calculated for next call
   return(rates_total);
  }
//+------------------------------------------------------------------+